org.springframework.cloud.dataflow.configuration.metadata

## Class BootApplicationConfigurationMetadataResolver

- java.lang.Object
- - org.springframework.cloud.dataflow.configuration.metadata.ApplicationConfigurationMetadataResolver
  - - org.springframework.cloud.dataflow.configuration.metadata.BootApplicationConfigurationMetadataResolver

-     public class BootApplicationConfigurationMetadataResolver
      extends ApplicationConfigurationMetadataResolver

  An `ApplicationConfigurationMetadataResolver` that knows how to look either inside Spring Boot uber-jars or an application Container Image's configuration labels.

  Supports Boot 1.3 and 1.4+ layouts thanks to a pluggable BootClassLoaderCreation strategy.

  Supports Docker and OCI image format for retrieving the metadata.

  Author:
    Eric Bottard, Christian Tzolov, Ilayaperumal Gopinathan, David Turanski

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BootApplicationConfigurationMetadataResolver(ClassLoader parent, ContainerImageMetadataResolver containerImageMetadataResolver)`
    `BootApplicationConfigurationMetadataResolver(ContainerImageMetadataResolver containerImageMetadataResolver)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `URLClassLoader` | `createAppClassLoader(org.springframework.core.io.Resource app)` For resolvers that support it, create a new ClassLoader that is able to load classes for the given app.
    `Map<String,Set<String>>` | `listPortNames(org.springframework.core.io.Resource app)`
    `List<org.springframework.boot.configurationmetadata.ConfigurationMetadataProperty>` | `listProperties(org.springframework.boot.loader.archive.Archive archive, boolean exhaustive)`
    `List<org.springframework.boot.configurationmetadata.ConfigurationMetadataProperty>` | `listProperties(org.springframework.core.io.Resource app, boolean exhaustive)` Return metadata about configuration properties that are documented via Spring Boot configuration metadata and visible in an app.

    - ### Methods inherited from class org.springframework.cloud.dataflow.configuration.metadata.ApplicationConfigurationMetadataResolver

      `listProperties`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BootApplicationConfigurationMetadataResolver

          public BootApplicationConfigurationMetadataResolver(ContainerImageMetadataResolver containerImageMetadataResolver)

    - #### BootApplicationConfigurationMetadataResolver

          public BootApplicationConfigurationMetadataResolver(ClassLoader parent,
                                                              ContainerImageMetadataResolver containerImageMetadataResolver)

  - ### Method Detail

    - #### listProperties

          public List<org.springframework.boot.configurationmetadata.ConfigurationMetadataProperty> listProperties(org.springframework.core.io.Resource app,
                                                                                                                   boolean exhaustive)

      Return metadata about configuration properties that are documented via Spring Boot configuration metadata and visible in an app.
      Specified by:
        `listProperties` in class `ApplicationConfigurationMetadataResolver`
      Parameters:
        `app` - a Spring Cloud Stream app; typically a Boot uberjar, but directories are supported as well
        `exhaustive` - return all metadata, including common Spring Boot properties
      Returns:
        the list of configuration metdata properties

    - #### listPortNames

          public Map<String,Set<String>> listPortNames(org.springframework.core.io.Resource app)

      Specified by:
        `listPortNames` in class `ApplicationConfigurationMetadataResolver`

    - #### listProperties

          public List<org.springframework.boot.configurationmetadata.ConfigurationMetadataProperty> listProperties(org.springframework.boot.loader.archive.Archive archive,
                                                                                                                   boolean exhaustive)

    - #### createAppClassLoader

          public URLClassLoader createAppClassLoader(org.springframework.core.io.Resource app)

      Description copied from class: `ApplicationConfigurationMetadataResolver`
      For resolvers that support it, create a new ClassLoader that is able to load classes for the given app. The default implementation returns an empty classloader
      Overrides:
        `createAppClassLoader` in class `ApplicationConfigurationMetadataResolver`
      Parameters:
        `app` - an app to create a ClassLoader for
      Returns:
        a new ClassLoader. Callers are responsible for closing the returned class loader.

Copyright © 2021 Pivotal Software, Inc.. All rights reserved.